module PuppetLocal
  class Command < Clamp::Command

    include Term::ANSIColor

    def system_command(command, options={})
      options.each do |name, value|
        command += ' '
        if value.is_a? String
          command += name + ' ' + Shellwords.escape(value)
        elsif value.is_a? TrueClass
          command += name
        end
      end
      system command
      raise 'Puppet apply failed' unless $?.success?
    end

    def run(arguments)
      begin
        super
      rescue Exception => e
        $stderr.print on_red ' '
        $stderr.print bold ' Error: '
        if e.message.empty?
          $stderr.puts 'Unknown error/Interrupt'
        else
          $stderr.puts e.message
        end
        exit 1
      end
    end
  end
end